"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("@src/api");
function useScrollbarWidth(runOnMount) {
    if (runOnMount === void 0) { runOnMount = true; }
    var scrollbarWidth = api_1.ref(0);
    var getScrollbarWidth = function () {
        // https://stackoverflow.com/a/13382873/974107
        // Creating invisible container
        var outer = document.createElement('div');
        outer.style.visibility = 'hidden';
        outer.style.overflow = 'scroll'; // forcing scrollbar to appear
        outer.style.msOverflowStyle = 'scrollbar'; // needed for WinJS apps
        document.body.appendChild(outer);
        // Creating inner element and placing it in the container
        var inner = document.createElement('div');
        outer.appendChild(inner);
        // Calculating difference between container's full width and the child width
        var scrollbarWidthValue = outer.offsetWidth - inner.offsetWidth;
        // Removing temporary elements from the DOM
        if (outer.parentNode)
            outer.parentNode.removeChild(outer);
        scrollbarWidth.value = scrollbarWidthValue;
    };
    api_1.onMounted(function () { return runOnMount && getScrollbarWidth(); });
    return { scrollbarWidth: scrollbarWidth, getScrollbarWidth: getScrollbarWidth };
}
exports.useScrollbarWidth = useScrollbarWidth;
